import React from 'react'
import PropTypes from 'prop-types'

export default class Keyframes extends React.Component {
    static propTypes = { script: PropTypes.func }
    state = { primitive: undefined, props: {}, resolve: () => null }
    componentDidMount() {
        this.props.script(this.next)
    }
    next = (primitive, props) => {
        return new Promise(resolve => {
            let from = this.instance && this.instance.propsAnimated.__getValue()
            this.setState(state => ({ primitive, props: { ...props, from: { ...from, ...props.from } }, resolve }))
        })
    }
    render() {
        const { primitive: Component, props, resolve } = this.state
        const { script, ...rest } = this.props
        return Component ? <Component ref={ref => (this.instance = ref)} {...rest} {...props} onRest={resolve} /> : null
    }
}